/******
 * Module of AMSCRACK
 **
 *   Copyright (C) 1998 David Khling
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *   My Email:   dkuehlin@hell1og.be.schule.de (valid till june 2000)
 *   Snailmail:
 *               David Khling
 *               Lion-Feuchtwanger-Str. 44
 *               12619 Berlin
 *               GERMANY
 **
 * Contains:
 *   C - function, that create the 512KByte look-up tables for the ASM-Module
 *   Cryptm.s .
 *   Also contains some of the other functions, that are needed by ASMCRACK,
 *   and that needn't to be programed in Assembler.
 * Needs:
 *   Xit's Crypt.c, it contains the function, that creates the small (72K)
 *   tables, that are needed, to create the bigger tables fast.
 */

#include <stdio.h>

void Info ()
{
  puts ("Subversion: ASM - crypt functions, using 580KByte lookup tables.\n");
}

typedef union {
   unsigned char  b[8];
   unsigned short i[4];
   struct {
      long  i0;
      long  i1;
   } b32;
   long long b64;
} C_block;


long long        S_P_E[4][65536/4];

extern long      SPE[2][8][64];

/**
 * Initializes my HUGE look-up tables
 */

void Init_DES ()
{
  int           I;
  void init_des();

  init_des ();  /* I was too lazy, to do this on my own... */

  for (I = 0; I < 65536/4; I++)
  {
    S_P_E[0][I] = 0xFFFFFFFFL&(SPE[0][0][I&63] ^ SPE[0][1][I>>8]);
    S_P_E[0][I] |= (long long)(SPE[1][0][I&63] ^ SPE[1][1][I>>8]) << 32;
    S_P_E[1][I] = 0xFFFFFFFFL&(SPE[0][2][I&63] ^ SPE[0][3][I>>8]);
    S_P_E[1][I] |= (long long)(SPE[1][2][I&63] ^ SPE[1][3][I>>8]) << 32;
    S_P_E[2][I] = 0xFFFFFFFFL&(SPE[0][4][I&63] ^ SPE[0][5][I>>8]);
    S_P_E[2][I] |= (long long)(SPE[1][4][I&63] ^ SPE[1][5][I>>8]) << 32;
    S_P_E[3][I] = 0xFFFFFFFFL&(SPE[0][6][I&63] ^ SPE[0][7][I>>8]);
    S_P_E[3][I] |= (long long)(SPE[1][6][I&63] ^ SPE[1][7][I>>8]) << 32;
  }
}

