// EthernetSpyDoc.h : interface of the CEthernetSpyDoc class
//
/////////////////////////////////////////////////////////////////////////////


class CEthernetSpyDoc : public CDocument
{
protected: // create from serialization only
	CEthernetSpyDoc();
	DECLARE_DYNCREATE(CEthernetSpyDoc)
	
// Attributes
private:
	EthernetHeaderFilter* HeaderFilter;
	TwoTalkingComputersFilter *TwoTalkFlt;
	int FilterType;
	BOOL IsSpyDlgActive;
	BOOL ThreadIsSuspended;
	BOOL ThreadIsRunning;
	UINT CurrentCheckedFilterItem;
	UINT CurrentCheckedPrioItem;
	
	CEthernetSpyGlobStatsDlg*	pGlobStatsDlg;
	CEthernetSpyPckTypeDlg*		pPckTypeDlg;
	CEthernetSpyDlg*			pSpyDlg;
	CEthernetSpyOptionsDlg*		pOptionsDlg;

public:
	BOOL IsPckTypeDlgOpen;
	BOOL IsGlobStatsDlgOpen;
			
	EthernetSpyReader SpyReader;
	
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEthernetSpyDoc)
	public:
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CEthernetSpyDoc();
	void OnSpyDlgClose();
	void OnPckTypeDlgClose();
	void OnGlobStatsDlgClose();
//	void OnTerminatedThread(void);
	
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	void Check_UnCheck_Item(UINT ItemID, UINT UnItemID);
	
// Generated message map functions
protected:
	//{{AFX_MSG(CEthernetSpyDoc)
	afx_msg void OnNetcardStartreading();
	afx_msg void OnNetcardStopreading();
	afx_msg void OnNetcardSetpriorityAbovenormal();
	afx_msg void OnNetcardSetpriorityHighest();
	afx_msg void OnNetcardSetpriorityIdle();
	afx_msg void OnNetcardSetpriorityNormal();
	afx_msg void OnNetcardSetpriorityTimecritical();
	afx_msg void OnNetcardShowglobalstatistics();
	afx_msg void OnNetcardShowpackettypesstatistics();
	afx_msg void OnNetcardShowspydialog();
	afx_msg void OnNetcardResumereading();
	afx_msg void OnNetcardSuspedreading();
	afx_msg void OnNetcardOptions();
	afx_msg void OnUpdateNetcardStartreading(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNetcardStopreading(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNetcardResumereading(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNetcardSuspedreading(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNetcardOptions(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNetcardShowspydialog(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNetcardShowglobalstatistics(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNetcardShowpackettypesstatistics(CCmdUI* pCmdUI);
	afx_msg void OnNetcardHeaderfilter();
	afx_msg void OnNetcardTwotalkingfilter();
	afx_msg void OnNetcardSoftwarefilterNone();
	afx_msg void OnAppAbout();
	afx_msg void OnNetcardHardwarefilter();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
